# 📖📖 OpenLeaf (Flutter eBook App) [![Codemagic build status](https://api.codemagic.io/apps/5e230defc5faa60315b1df62/5e230defc5faa60315b1df61/status_badge.svg)](https://codemagic.io/apps/5e230defc5faa60315b1df62/5e230defc5faa60315b1df61/latest_build)

[![Twitter Follow](https://img.shields.io/twitter/follow/iamjideguru.svg?style=social)](https://twitter.com/iamjideguru)

A simple Flutter app to Read and Download books. The Books included in the app
are from the [Public Domain](https://en.wikipedia.org/wiki/Public_domain)
(Expired Copyright and completely free).

<a href="http://www.feedbooks.com/"><img src="ss/logo_feedbooks.png" width="200"/></a>
<br>

The [Feedbooks API](http://www.feedbooks.com/api) was used to fetch books. <br>
<br>
<a href="https://www.vecteezy.com/vector-art/599678-book-reading-logo-and-symbols-template-icons">App
icon</a> <br> <br>
To download this app, <a href="https://codemagic.io/apps/5e230defc5faa60315b1df62/5e230defc5faa60315b1df61/latest_build">click here</a> to see the codemagic builds. You can choose to install the `apk`.
You can download from the appstore if you use an iPhone, iPad or a Mac with Silicon chip.
<br>
<a href="https://apps.apple.com/app/openleaf/id6450374275"><img src="https://www.freepnglogos.com/uploads/app-store-logo-png/download-on-the-app-store-logo-png-23.png" width="200"></img></a>
<br> Please star⭐ the repo if you like what you see😉.

## 💻 Requirements

- Any Operating System (ie. MacOS X, Linux, Windows)
- Any IDE with Flutter SDK installed (ie. IntelliJ, Android Studio, VSCode etc)
- A little knowledge of Dart and Flutter

## ✨ Features

- [x] Download eBooks.
- [x] Read eBooks.
- [x] Favorites.
- [x] Dark Mode
- [x] Swipe to delete downloads.

## 📸 ScreenShots

<!-- <img src="ss/mockup.png"/> -->

| Light                             | Dark                              |
| --------------------------------- | --------------------------------- |
| <img src="ss/1.png" width="300">  | <img src="ss/2.png" width="300">  |
| <img src="ss/3.png" width="300">  | <img src="ss/4.png" width="300">  |
| <img src="ss/5.png" width="300">  | <img src="ss/6.png" width="300">  |
| <img src="ss/7.png" width="300">  | <img src="ss/8.png" width="300">  |
| <img src="ss/9.png" width="300">  | <img src="ss/10.png" width="300"> |
| <img src="ss/11.png" width="300"> | <img src="ss/12.png" width="300"> |
| <img src="ss/13.png" width="300"> | <img src="ss/14.png" width="300"> |

##### Desktop

<img src="ss/desktop_1.png" width="800">

## 🔌 Plugins

| Name                                                                   | Usage                                         |
| ---------------------------------------------------------------------- | --------------------------------------------- |
| [**Riverpod**](https://pub.dev/packages/flutter_riverpod)              | State Management                              |
| [**Sembast**](https://pub.dev/packages/sembast)                        | NoSQL database to store Favorites & Downloads |
| [**XML2JSON**](https://pub.dev/packages/xml2json)                      | Convert XML to JSON                           |
| [**DIO**](https://pub.dev/packages/dio)                                | Network calls and File Download               |
| [**Iridium Reader**](https://github.com/Mantano/iridium_reader_widget) | Plug and play reader widget for epubs         |

## 🤓 Author(s)

**Festus Babajide Olusegun**
[![Twitter Follow](https://img.shields.io/twitter/follow/iamjideguru.svg?style=social)](https://twitter.com/iamjideguru)

## 🔖 LICENCE

[Apache-2.0](https://github.com/JideGuru/FlutterEbookApp/blob/master/LICENSE)

<a href="https://github.com/JideGuru/FlutterEbookApp">
        <img width="500" alt="Star History Chart" src="https://api.star-history.com/svg?repos=JideGuru/FlutterEbookApp&type=Date">
      </a>
